<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rubén Díaz <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Where is Jisko located?. Without http:// and www.
$globals['base'] = 'localhost';

// Name of the script (used in cookies, Twitter posting, etc). Please do not use spaces or dots.
// Also, it is recommended to be different than 'Jisko'
define('NAME', 'Jisko');

// Keywords and description META tags of the website
define('META_KEYWORDS', '%name, microblogging, nanoblogging, %language');
define('META_DESCRIPTION', '%name microblogging site powered by Jisko, an open-source microblogging application.');
define('META_ROBOTS', 'noodp,noydir');

// Domain from mails will be sent
define('DOMAIN', 'localhost');

// MySQL settings
define('DB_HOST', 'localhost');
define('DB_PORT', '3306');
define('DB_USER', 'root');
define('DB_PASSWORD', 'root');
define('DB_NAME', 'jisko');

//IF YOU ARE HOSTING JISKO ON A SHARED HOST AND YOU'RE HAVING TROUBLE WITH YOUR INSTALLATION, REMOVE THE "#" OF THE NEXT LINE
#define('SHARED_HOST', true);

//The email of the administrator.
define('ADMIN_MAIL', 'admin@foo.bar');
//Show sthe Admin mail at the bottom of any page or in some contact emails
define('PUBLIC_ADMIN_MAIL', true); 

//Uncomment the next line if you want to alert your users about an abuse mail
#define('ABUSE_MAIL', 'abuse@foo.bar');

//The password to execute the cron.php file.
define('CRON_PW', '1234');

//How many notes you want to load by page.
define('NOTES_PER_PAGE', 25);

//The language you want to have by default.
define('DEFAULT_LANG', 'english');

//The theme you want to load by default
define('DEFAULT_THEME', 'transparency');

//The symbol you want to have between you proyect name and the page. For example: Jisko "-" Homepage.
define('SEPARATOR', '-');

//Do you want to debug MySQL errors to a debug.log file?
define('DEBUG', false);

//If you want to show an alert in the main page, uncomment the next line and fill it with your message
# define('ALERT', 'Something went wrong!');

//Do you want to turn off your Jisko platform with a message? Uncomment the next line
# define('MAINTENANCE', 'Squirrel working...');

// StatCounter info (optional)
# define('SC_PROJECT', '123456');
# define('SC_PARTITION', '12');
# define('SC_SECURITY', '1a2b3c');
# define('SC_URL', 'http://c12.statcounter.com/123456/0/1a2b3c/1/');

//It Shows a "blog" link in the bottom of the page
define('BLOG', 'http://blog.jisko.net');

//It Show a "wiki" link in the bottom of the page
#define('WIKI', 'http://wiki.jisko.net');

//If you want to provide a TOS, then uncomment the next line and place the content in a file called 'tos.php' at the root folder of your Jisko installation.
#define('TOS', true);

// Main XMPP/Jabber settings
define('JABBER_HOST', 'talk.google.com');
define('JABBER_PORT', 5222);
define('JABBER_USER', 'bot');
define('JABBER_PASSWORD', '');

// Feed XMPP/Jabber settings
define('JABBER_FEED_HOST', 'talk.google.com');
define('JABBER_FEED_PORT', 5222);
define('JABBER_FEED_USER', 'public');
define('JABBER_FEED_PASSWORD', '');
define('JABBER_FEED_ALLOWED', 'outime@gmail.com;another@one.com;john@doe.com');

// Misc XMPP/Jabber settings
define('JABBER_DOMAIN', 'jisko.net');
define('JABBER_RESOURCE', 'Turn me on with !on');
define('JABBER_INTERVAL', 1);

// Seconds to wait to post another note
define('WAIT_UNTIL_REPOST', 3);

// Seconds to wait to follow another user
define('WAIT_UNTIL_REFOLLOW', 15);

// Set the next line to "true" if you want to use Mbstring PHP extension support: Which solves some problems with unicode characters
define('ENABLE_MBSTRING', false);

// Remove '#' if you want to receive an email every time an user joins your microblogging platform.
// It will send an email to your ADMIN_MAIL email. If ADMIN_MAIL is not set, then you won't receive any email.
#define('ALERT_ON_NEWUSER', true);

// Remove '#' if you want to receive an email every time an user deletes an account on your
// microblogging platform.
// It will send an email to your ADMIN_MAIL email. If ADMIN_MAIL is not set, then you won't receive any email.
#define('ALERT_ON_DELUSER', true);

// Turn on or off invitations
// define('USE_INVITATION', true);

// Remove '#' if you don't want to send a confirmation email
#define('NO_CONFIRMATION_EMAIL', true);

// The page you want to load when an unlogged user opens your microblogging platform.
// Default pages: 'public_notes' or 'homepage'
$globals['main_page'] = 'home_page';

// Select which URL shorter services are allowed to use.
// Available ones are:
// 3.ly, ves.cat, pic.gd, is.gd, bit.ly, j.mp, urlal.com, u.nu, ta.gd, tr.im, tinyurl.com, wipi.es, xrl.us, xn--ogi.ws, wn--vgi.ws
// xn--3fi.ws, xn--egi.ws, xn--9gi.ws, xn--5gi.ws, xn--1ci.ws, xn--odi.ws, xn--rei.ws, xn--cwg.ws, xn--bih.ws, xn--fwg.ws,
// xn-l3h.ws, tinyarro, cort.as
$globals['allowed_shorter_services'] = array('3.ly', 'ves.cat', 'pic.gd', 'is.gd', 'bit.ly', 'j.mp', 'urlal.com', 'u.nu', 'ta.gd', 'tr.im',
'tinyurl.com', 'wipi.es', 'xrl.us', 'xn--ogi.ws', 'xn--vgi.ws', 'xn--3fi.ws', 'xn--egi.ws', 'xn--9gi.ws', 'xn--5gi.ws', 'xn--1ci.ws',
'xn--odi.ws', 'xn--rei.ws', 'xn--cwg.ws', 'xn--bih.ws', 'xn--fwg.ws', 'xn--l3h.ws', 'tinyarro', 'cort.as');

// Default shorter service
define('DEFAULT_SHORTER_SERVICE', 'u.nu');

// 3.ly API Code. If you allow your users to use 3.ly, then uncomment the next line and fill it with your API Code
define('THREELY_APICODE', '');

// Bit.ly & J.mp credentials for shorting urls. If you allow your users to use Bit.ly or J.mp, then uncomment the next line and fill it with you API Code.
define('BITLY_LOGIN', '');
define('BITLY_APICODE', '');

// Avatar & background allowed extensions
$globals['allowed_extensions'] = array('jpg', 'jpeg', 'png', 'gif');

// Upload denied extensions
$globals['denied_extensions'] = array('php', 'bat', 'scr', 'com', 'exe', 'torrent');

// reCAPTCHA codes
$globals['recaptcha_public_key'] = '';
$globals['recaptcha_private_key'] = '';

// Languages
// include here all languages you want to use
$globals['languages'] = array('asturian' => 'Asturian', 'catalan' => 'Catalan', 'spanish' => 'Spanish',
							  'galician' => 'Galician', 'basque' => 'Basque', 'arabic' => 'Arabic',
							  'bulgarian' => 'Bulgarian', 'english' => 'English', 'esperanto' => 'Esperanto',
							  'french' => 'French', 'german' => 'German', 'japanese' => 'Japanese',
							  'mongolian' => 'Mongolian', 'portuguese' => 'Portuguese', 'turkish' => 'Turkish',
							  'aragonese' => 'Aragonese', 'brazilian_portuguese' => 'Brazilian Portuguese',
							  'chinese' => 'Chinese', 'croatian' => 'Croatian', 'dutch' => 'Dutch',
							  'english_united_kingdom' => 'English (UK)', 'greek' => 'Greek',
							  'italian' => 'Italian', 'low_german' => 'Low German', 'polish' => 'Polish',
							  'portuguese_portugal' => 'Portuguese (Portugal)', 'romanian' => 'Romanian',
							  'russian' => 'Russian', 'swedish' => 'Swedish', 'vietnamese' => 'Vietnamese');

// Misc
$globals['themes'] = array('colorful', 'transparency', 'dark_transparency', 'block', 'seriouspeople');
$globals['logo'] = array('logo_orange.png', 'logo_green.png', 'logo_blue.png');
$globals['forbidden_usernames'] = array ('home', 'login', 'register', 'logout', 'notes', 'drop', 'forgot',
										 'avatar', 'invite', 'preferences', 'follow', 'favorites', 'public',
										 'profile', 'rss', 'followers', 'following', 'search', 'cron',
										 'download', 'post', 'ajax', 'mobile', 'report', 'group', 'groups',
										 'direct_messages', 'favorites', 'account', 'trouble_login',
										 'resend_mail');

//Menubar links
// If you want to display a link to another location in the menubar, just add it here.
// *** INSTRUCTIONS ***
// The syntax is 'TITLE' => 'URL'. You have to follow the PHP Array syntax
// YOU HAVE TO PUT http:// at the beggining of the URL
// For example: array('Jisko project' => 'http://www.jisko.org', 'My hosting provider' => 'http://www.myhostingprovider.com')

$globals['menubar_links'] = array();

//Footer links
// If you want to display a link to another location in the footer, just add it here.
// *** INSTRUCTIONS ***
// The syntax is 'TITLE' => 'URL'. You have to follow the PHP Array syntax
// YOU HAVE TO PUT http:// at the beggining of the URL
// For example: array('Jisko project' => 'http://www.jisko.org', 'My hosting provider' => 'http://www.myhostingprovider.com')

$globals['footer_links'] = array();

// Post-configuration (you *should not* touch this!)
if (isset($_SERVER['HTTPS'])) define('BASE', 'https://'.$globals['base'].'/'); else define('BASE', 'http://'.$globals['base'].'/');

?>