<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rubén Díaz <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

function showNoteMobile($row) {
	global $db;
	global $_USER;
	
	if($row['type'] == 'twitter' || $row['type'] == 'twitter_reply') return showTwitMobile($row['id']);
	
	$noteInfo = $db->getNoteCombined($row['id']);
	if(!$noteInfo) return false;
	extract($noteInfo);
	if($type == 'private') {
		if( strtolower(trim($_USER['username'])) !== strtolower(trim($to)) ) {
			if($user_id != $_USER['ID']) return false;
		}
	}
	$note = utf8_htmlentities($note);
	$note = preg_replace_callback('/\[(\*|\/|_|\-)(.+)\]/U',
				create_function('$matches', '
					switch ($matches[1]) {
						case "*":
							return "<b>" . $matches[2] . "</b>";
						case "/":
							return "<i>" . $matches[2] . "</i>";
						case "_":
							return "<u>" . $matches[2] . "</u>";
						case "-":
							return "<s>" . $matches[2] . "</s>";
					}
			'), $note);
	
	$note = preg_replace('#https?://[^.\s]+\.[^\s]+#ix', '<a href="$0" rel="external" class="external">$0</a>', $note);
	
	if ($twitter) $note = preg_replace('/(\s|\A)(@){1}(\w+)/', '$1<a href="http://m.twitter.com/$3">$2$3</a>', $note);
	else $note = preg_replace('/(\s|\A)(@){1}(\w+)/', '$1<a href="'.BASE.'ajax/note?mode=m&nav=link&id='.$timestamp.'-$3">$2$3</a>', $note);
	//if($type == 'private') $note = preg_replace('/(\s|\A)(!){1}(\w+)/', '$1<a href="'.BASE.'ajax/note?type=private&f='.$ID.'&mode=m&nav=link&id='.$timestamp.'-$3">$2$3</a>', $note);

	echo '<li';
	if ($replying && ($to == $_USER['username'])) echo ' style="background-color:#FFF8AF"';
	echo '><em class="us">';
	echo '<a href="'.BASE.'mobile/'.$username.'">'.$username.'</a></em>';
	echo '<em class="nl"> '.$note.'</em>';
	echo '<em class="t"> '.showTimeAgo($timestamp).'</em></li>';
	echo "\n";
}

function showNoteMobileiPhone($row, $reducedAjax = false) {
	global $db;
	global $_USER;
	
	if($row['type'] == 'twitter' || $row['type'] == 'twitter_reply') return showTwitMobileiPhone($row['id'], $reducedAjax);
	
	if ($reducedAjax) $return = array();
	
	$noteInfo = $db->getNoteCombined($row['id']);
	if(!$noteInfo) return false;
	extract($noteInfo);
	if($type == 'private') {
		if( strtolower(trim($_USER['username'])) !== strtolower(trim($to)) ) {
			if($user_id != $_USER['ID']) return false;
		}
	}
	$note = utf8_htmlentities($note);
	$note = preg_replace_callback('/\[(\*|\/|_|\-)(.+)\]/U',
				create_function('$matches', '
					switch ($matches[1]) {
						case "*":
							return "<b>" . $matches[2] . "</b>";
						case "/":
							return "<i>" . $matches[2] . "</i>";
						case "_":
							return "<u>" . $matches[2] . "</u>";
						case "-":
							return \'<span class="text-decoration:line-through">\' . $matches[2] . \'</span>\';
					}
			'), $note);
	
	//Fixing a XSS issue reported by @kosugi
	$note = str_replace('<', '&lt;', $note);
	
	$note = preg_replace('#https?://[^.\s]+\.[^\s]+#ix', '<a href="$0" rel="external">$0</a>', $note);
	
	if ($twitter) $note = preg_replace('/(\s|\A)(@){1}(\w+)/', '$1<a href="http://m.twitter.com/$3">$2$3</a>', $note);
	else $note = preg_replace('/(\s|\A)(@){1}(\w+)/', '$1<a href="'.BASE.'ajax/note?mode=mi&nav=link&id='.$timestamp.'-$3">$2$3</a>', $note);
	//if($type == 'private') $note = preg_replace('/(\s|\A)(!){1}(\w+)/', '$1<a href="'.BASE.'ajax/note?type=private&f='.$ID.'&mode=m&nav=link&id='.$timestamp.'-$3">$2$3</a>', $note);
	
	if ($reducedAjax) {
		$return['text'] = $note;
		$return['id'] = $ID;
		$return['time_ago'] = showTimeAgo($timestamp);
		$return['username'] = $username;
		if (preg_match("/@\b".$_USER['username']."\b/i", $note) == 1) $return['replying'] = true;
		if ($attached_file) $return['attached_file'] = $attached_file;
		return $return;
	}
	else {

		echo '<tr><td onclick="location.href=\''.MBASE.'statuses/'.$row['id'].'\'"';

		if ($_USER) {
			if (strtolower($to) == strtolower($_USER['username'])) echo ' style="background-color: #FFF8AF"';
		}
		echo '>';
		echo '<a href="'.MBASE.'user/'.$username.'" class="user">'.$username.'</a>';
	
	
		echo ' '.put_smileys(trim(stripslashes($note)));
		echo '<em class="t"> '.showTimeAgo($timestamp).'</em></td></tr>'."\n";
	}
}

function showTwitMobile ($noteID) {
	global $db; 
	global $_USER;
	
	$noteInfo = $db->getTwit($noteID);

	extract($noteInfo);
	
	$note = preg_replace('#https?://[^.\s]+\.[^\s]+#ix', '<a href="$0" rel="external" class="external">$0</a>', $note);
	
	$note = stripslashes($note);
	
	$note = preg_replace('/(\s|\A)(@|!){1}(\w+)/', '$1<a href="http://twitter.com/$3" rel="external" class="external">$2$3</a>', $note); 

	$serial = unserialize(stripslashes($serial));
	extract($serial);

	echo '<li style="background:#EFFFFF"><em class="us">';
	echo '<a href="http://m.twitter.com/'.$username.'">'.$username.' (twitter)</a></em>';
	echo '<em class="nl"> '.$note.'</em>';
	echo '<em class="t"> '.showTimeAgo($timestamp).'</em></li>';
	echo "\n";

}

function showTwitMobileiPhone ($noteID, $reducedAjax = false) {
	global $db; 
	global $_USER;
	
	$noteInfo = $db->getTwit($noteID);
	
	extract($noteInfo);
	
	if ($reducedAjax) $return = array();
	
	$note = preg_replace('/(?:[\w^_]{3,}:\/\/)(?:(?:[\w^_]{2,}\.)?[\w\-]{2,}(?:\.[\w^_]{2,})+){1}[^\s\[\]\(\)<>,";\.]*(?:\.\w+)*[^\s\[\]\(\)<>,";\.]*/', '<a href="$0" rel="external" class="external">$0</a>', $note);
	
	$note = stripslashes($note);
	
	$note = preg_replace('/(\s|\A)(@|!){1}(\w+)/', '$1<a href="http://twitter.com/$3" rel="external" class="external">$2$3</a>', $note); 

	$serial = unserialize(stripslashes($serial));
	extract($serial);
	
	if ($reducedAjax) {
		$return['text'] = $note.' ';
		$return['id'] = $ID;
		$return['time_ago'] = showTimeAgo($timestamp);
		$return['username'] = $username;
		if (preg_match("/@\b".$_USER['username']."\b/i", $note) == 1) $return['replying'] = true;
		if ($attached_file) $return['attached_file'] = $attached_file;
		return $return;
	}
	else {
		echo '<tr><td onclick="location.href=\''.MBASE.'statuses/twit-'.$noteID.'\'" style="background:#EFFFFF">';
		echo '<a href="http://m.twitter.com/'.$username.'" class="user">'.$username.' (twitter)</a>';
		echo ' '.$note;
		echo '<em class="t"> '.showTimeAgo($timestamp).'</em></td></tr>'."\n";
	}
}

/* PAGINATION (DIGG-STYLE PAGINATION BY STRANGER STUDIOS) */
function getPaginationStringMobile($targetStart, $totalitems, $page, $limit = NOTES_PER_PAGE, $adjacents = 1, $pagestring = "?page=") {
	
	$prev = $page - 1;									//previous page is page - 1
	$next = $page + 1;									//next page is page + 1
	$lastpage = $page + 2;				//lastpage is = total items / items per page, rounded up.
	$lpm1 = $lastpage - 1;								//last page minus 1
	
	$pagination = "";
	if($lastpage > 1)
	{	
		$pagination .= "<div class=\"pa\"";
		if($margin || $padding)
		{
			$pagination .= " style=\"";
			if($margin)
				$pagination .= "margin: $margin;";
			if($padding)
				$pagination .= "padding: $padding;";
			$pagination .= "\"";
		}
		$pagination .= ">";

		//previous button
		if ($page > 1) 
			$pagination .= "<a href=\"$targetStart$pagestring$prev\">&lt;</a>";
		else
			$pagination .= "<span class=\"dis\">&lt;</span>";	
		
		//pages	
		if ($lastpage < 7 + ($adjacents * 2))
		{	
			for ($counter = 1; $counter <= $lastpage; $counter++)
			{
				if ($counter == $page)
					$pagination .= "<span class=\"cu\">$counter</span>";
				else
					$pagination .= "<a href=\"$targetStart$pagestring$counter\">$counter</a>";					
			}
		}
		elseif($lastpage >= 7 + ($adjacents * 2))
		{
			if($page < 1 + ($adjacents * 3))		
			{
				for ($counter = 1; $counter < 4 + ($adjacents * 2); $counter++)
				{
					if ($counter == $page)
						$pagination .= "<span class=\"cu\">$counter</span>";
					else
						$pagination .= "<a href=\"$targetStart$pagestring$counter\">$counter</a>";					
				}
				$pagination .= "...";
				$pagination .= "<a href=\"$targetStart$pagestring$lpm1\">$lpm1</a>";
				$pagination .= "<a href=\"$targetStart$pagestring$lastpage\">$lastpage</a>";		
			}
			elseif($lastpage - ($adjacents * 2) > $page && $page > ($adjacents * 2))
			{
				$pagination .= "<a href=\"$targetStart$pagestring1\">1</a>";
				$pagination .= "<a href=\"$targetStart$pagestring2\">2</a>";
				$pagination .= "...";
				for ($counter = $page - $adjacents; $counter <= $page + $adjacents; $counter++)
				{
					if ($counter == $page)
						$pagination .= "<span class=\"cu\">$counter</span>";
					else
						$pagination .= "<a href=\"$targetStart$pagestring$counter\">$counter</a>";					
				}
				$pagination .= "...";
				$pagination .= "<a href=\"$targetStart$pagestring$lpm1\">$lpm1</a>";
				$pagination .= "<a href=\"$targetStart$pagestring$lastpage\">$lastpage</a>";		
			}
			else
			{
				$pagination .= "<a href=\"$targetStart$pagestring1\">1</a>";
				$pagination .= "<a href=\"$targetStart$pagestring2\">2</a>";
				$pagination .= "...";
				for ($counter = $lastpage - (1 + ($adjacents * 3)); $counter <= $lastpage; $counter++)
				{
					if ($counter == $page)
						$pagination .= "<span class=\"cu\">$counter</span>";
					else
						$pagination .= "<a href=\"$targetStart$pagestring$counter\">$counter</a>";					
				}
			}
		}
		
		if ($page < $counter - 1) 
			$pagination .= "<a href=\"$targetStart$pagestring$next\">&gt;</a>";
		else
			$pagination .= "<span class=\"dis\">&gt;</span>";
		$pagination .= "</div>\n";
	}		
	
	return $pagination;

}

function getPaginationStringMobileiPhone($type) {
	return '<div class="pa"><a href="javascript:mn(\''.$type.'\')" id="pgi">'.__('more notes').'</a></div>';
}

?>