<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rubén Díaz <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

global $_USER;
global $db;

$params = PARAMS;

if (defined('SEEING_PROFILE')) {
	global $_PROFILE;
	$userInfo = $_PROFILE;
	$user = SEEING_PROFILE;
	$id = $_PROFILE['ID'];
	$profile = true;
	$external = true;
} elseif ($_USER) {
	$profile = true;
	if (MODULE != 'tag' || (MODULE == 'tag' && (!$params))) {
		$userInfo = $_USER;
		$user = $_USER['username'];
		$id = $_USER['ID'];
	}
	else $tags = true;
}
else {
	if (MODULE == 'tag') {
		if (strlen($params) > 0) {
			$profile = true;
			$tags = true;
		}
		else $profile = true;
	}
	else $profile = false;
}

if ($profile == true) {
echo '<div class="user_side">';
	if (!$tags) {
		if (!$userInfo['avatar']) $avatar = BASE.'static/img/avatar/default_side.png';
		else $avatar = get_avatar_url($user, $userInfo['avatar'], 'side');
		echo '<img src="'.$avatar.'" alt="'.__('Avatar').'" /><br />
	<a href="'.BASE.$user.'" class="user">'.$user.'</a><br />';
	}
	else echo '<img src="'.BASE.'static/img/icons/tag_blue.png" class="tag" /> <a href="'.BASE.'tag/'.PARAMS.'" class="user">#'.utf8_htmlentities(PARAMS).'</a><br />';
	if ($external == true) {
		if ($_USER && $_USER['ID'] != $_PROFILE['ID']) {
			$me = $_USER['username'];
			$currentUserID = $_USER['ID'];	
			$follows = $db->checkFollowing($currentUserID, $id);
			if ($follows) {
				$button_text = __('Unfollow');
			} else {
				$button_text = __('Follow');
			}
			$sbtn = 'action'.md5($userInfo['ID']);
			$ignores = in_array($userInfo['ID'], $_USER['ignored']);
			echo '<input type="button" value="'.$button_text.'" class="submit_follow" onclick="follow('.$userInfo['ID'].', \''.$sbtn.'\');" id="'.$sbtn.'" ';
			if ($ignores) echo 'disabled ';
			echo '/><br />';
			$btn = 'action_ignore'.md5($userInfo['ID']);
			if($ignores) {
				$ignore_text = __('Unignore');
			} else {
				$ignore_text = __('Ignore');
			}
			echo '
			<input type="button" value="'.$ignore_text.'" class="submit" onclick="followbtn = \''.$sbtn.'\'; ignore('.$_PROFILE['ID'].', \''.$btn.'\');" id="'.$btn.'" /><br />
			<br />
			<span class="report_button"><a href="'.BASE.'report/'.$_PROFILE['username'].'" onclick="return confirm(\''.__('-- IMPORTANT NOTICE --\n\nSome reasons to report an account can be:\n\n- SPAM\n- Offensive content\n- Duplicated account\n- Unlawful attached files\n- Illicit purposes\n\nYou must be completely SURE that the user you are reporting is not following our Terms of Service. And remember this:\n\n- You will remain in anonymity\n- When finishing this, you will not get any notification, but report has been sent\n- Fake or duplicated reports means the blocking of your account!\n\nIf after reading this, you still want to report this account, go forward, we are grateful for your help!').'\');">'.__('Report').'</a></span>';
		}
	}
	
	if (!$tags) extract($userInfo);

	echo '</div>
	<div class="info_title"><img src="'.BASE.'static/img/icons/information.png" alt="'.__('About').'" /> '.__('About').'</div>
	<div class="info_user">';
	if (!$tags) {
		if ($realname) echo '<span class="bold">'.__('Name').'</span> '.utf8_htmlentities($realname).'<br />';
		if ($location) echo '<span class="bold">'.__('Location').'</span> '.utf8_htmlentities($location).'<br />';
		if ($url) echo '<span class="bold">'.__('Webpage').'</span> <a href="'.utf8_htmlentities($url).'" rel="external" class="external">'.str_replace(array('www.', 'http://'), '', utf8_htmlentities($url)).'</a><br />';
		if ($bio) echo '<span class="bold">'.__('Bio').'</span> '.utf8_htmlentities($bio).'<br />';
	}
	else $options = $db->getInfoTag(PARAMS, true);
	
	if (!$tags) echo '<span class="bold">'.__('Since').'</span> '.date('d/m/Y', $since);
	else {
		if (!$options['since']) $since = 'never';
		else $since = date('d/m/Y', $options['since']);
		echo '<span class="bold">'.__('First note').'</span> '.$since;
		if ($options['founder']) echo '<br /><span class="bold">'.__('First poster').'</span> <a href="'.BASE.$options['founder'].'">'.$options['founder'].'</a>';
	}
	
	echo '<br />';
	if ($external == true) {
		$calc = time() - $last_seen;
		if ($calc < 300) $content = __('<span style="color:green">online</span>');
		else {
			if ($calc < 3600) {
				$string = round($calc / 60);
				$content = str_replace('%s', $string, __('%s minutes ago'));
			} elseif ($calc < 86400) {
				$string = round($calc / 3600);
				if ($string == 1) $content = str_replace('%s', $string, __('%s hour ago'));
				else $content = str_replace('%s', $string, __('%s hours ago'));
			} elseif ($calc < 2678400) {
				$string = round($calc / 86400);
				if ($string == 1) $content = str_replace('%s', $string, __('%s day ago'));
				else $content = str_replace('%s', $string, __('%s days ago'));
			} else {
				$content = __('more than 1 month');
			}
		}
		echo '<span class="bold">'.__('Activity').'</span> '.$content.'<br />';
	}
	if (!$tags) {
		$following = $db->countFollowing($ID);
		$followers = $db->countFollowers($ID);
		$favorites = $db->countNotes('favorites', $ID);
		$privates = $db->countNotes('private', $username);
		$notes = $db->countNotes('archive', $ID);
	}
	else {
		$notes = $db->countNotes('tag', PARAMS);
	}
	echo '</div>';
	echo '<div class="info_title"><img src="'.BASE.'static/img/icons/chart_bar.png" alt="'.__('Stats').'" /> '.__('Stats').'</div>';
	echo '<div class="info_user">';
	if (!$tags) {
		echo '<span class="bold">';
		if ($external == true) echo '<a href="'.BASE.$user.'/following">';
		else echo '<a href="'.BASE.'following">';
		echo __('Following').'</a></span> '.$following.'<br />';
		echo '<span class="bold">';
		if ($external == true) {
			if ($show_followers) echo '<a href="'.BASE.$user.'/followers">';
		}
		else echo '<a href="'.BASE.'my_followers">';
		echo __('Followers');
		if ($external == true) {
			if ($show_followers) echo '</a>';
		}
		else echo '</a>';
		echo '</span> <span id="sfollowers">'.$followers.'</span><br />';
		echo '<span class="bold">';
		if ($external == true) echo '<a href="'.BASE.$_PROFILE['username'].'/favorites">';
		else echo '<a href="'.BASE.'notes/favorites">';
		echo __('Favorites').'</a></span> <span id="sfavorites">'.$favorites.'</span><br />';
		if (!$external) {
			echo '<span class="bold"><a href="'.BASE.'notes/private">'.__('Private').'</a></span> <span id="ajax_privates">'.$privates;
			if($unread_privates) echo ' <strong>('.$unread_privates.')</strong>';
			echo '</span><br />';
		}
	}
	echo '<span class="bold">'.__('Notes').'</span> <span id="ajax_notes">'.$notes.'</span>';
	if ($tags) {
		$w_rate = round(($notes / (time() - $options['since']) * 60), 2);
		echo '<br /><span class="bold">'.__('Writing rate').'</span> <strong>'.$w_rate.'</strong>/minute';
		if ($options['max_poster_username']) echo '<br /><span class="bold">'.__('Max. poster').'</span> <a href="'.BASE.$options['max_poster_username'].'">'.$options['max_poster_username'].'</a> ('.$options['max_poster_quantity'].' '.__('notes').')';
	}
	echo '</div>';
	$result = $db->getFollowing($ID, 0, 25);
	if (count($result) > 0) {
		echo '<div class="info_title"><img src="'.BASE.'static/img/icons/refresh.png" alt="'.__('Following').'" /> '.__('Following').'</div><div class="info_user">';
		foreach ($result as $follower) showFollower($follower);
		if (count($result) > 24) {
			echo '<br /><span class="bold">';
			if ($external == true) echo '<a href="'.BASE.$user.'/following/">';
			else echo '<a href="'.BASE.'following">';
			echo __('more').' &raquo;</a></span>';
		}
		echo '</div>';
	}
	
	$query = $db->send("SELECT `tag`, COUNT(`id`) FROM tags_n WHERE (UNIX_TIMESTAMP() - `timestamp`) < 86400 GROUP BY `tag` ORDER BY COUNT(`id`) DESC LIMIT 5");
	
	echo '<div class="info_title"><img src="'.BASE.'static/img/icons/tag_blue.png" alt="'.__('Most used tags').'" /> '.__('Today most used tags').'</div><div class="info_user">';
	while ($row = mysql_fetch_row($query)) {
		echo '<a href="'.BASE.'tag/'.$row[0].'">#'.$row[0].'</a><br>';
	}
	echo '<br><span class="bold"><a href="'.BASE.'tag/">'.__('more').' &raquo;</a></span></div>';
	
	if (defined('USE_INVITATION')) {
		if ((USE_INVITATION == true) && ($_USER['invitations'] > 0) && (!$external)) {
			echo '<div class="info_title">'.__('Invitations').'</div>';
			echo '<div class="info_user">';
			echo '<form method="post" action="invite">';
			echo '<p><input name="email" class="input_invite" value="'.__('E-mail...').'" onblur="if(this.value==\'\') this.value\''.__('E-mail...').'\';" onfocus="if(this.value==\''.__('E-mail...').'\') this.value=\'\';" type="text" /></p>';
			echo '<p><input type="submit" class="submit" value="'.__('Send!').'"> '.$_USER['invitations'].' '.__('invitations left').'</p>';
			echo '</form>';
			echo '</div>';
		}
	}
}
else {
	doLoginForm();
}

if ($_PROFILE['private'] != 1 && $_USER['private'] != 1) {

	echo '<div class="info_title">'.__('RSS').'</div>';
	echo '<div class="info_feeds">';
	echo '<ul class="feed">';
	echo '<li><a href="'.BASE.'statuses/public_timeline.rss"><img src="'.BASE.'static/img/icons/feed.png" alt="Feed" /> '.__('Public notes').'</a></li>';
	
	if(isset($_PROFILE['username'])) {
		echo '<li><a href="'.BASE.'rss/profile?u='.$_PROFILE['username'].'"><img src="'.BASE.'static/img/icons/feed.png" alt="Feed" /> '.__('Notes').'</a></li>';
		echo '<li><a href="'.BASE.'rss/friends?u='.$_PROFILE['username'].'"><img src="'.BASE.'static/img/icons/feed.png" alt="Feed" /> '.__('Friends notes').'</a></li>';
	
	} elseif($_USER) {
		if($_USER['private'] == '0') echo '<li><a href="'.BASE.'rss/profile?u='.$_USER['username'].'"><img src="'.BASE.'static/img/icons/feed.png" alt="Feed" /> '.__('Notes').'</a></li>';
		echo '<li><a href="'.BASE.'rss/friends?u='.$_USER['username'].'"><img src="'.BASE.'static/img/icons/feed.png" alt="Feed" /> '.__('Friends notes').'</a></li>';
	}
	
	if ($tags) {
		echo '<li><a href="'.BASE.'rss/tag/'.PARAMS.'"><img src="'.BASE.'static/img/icons/feed.png" alt="Feed" /> '.__('Tag #').PARAMS.'</a></li>';
	}

	echo '</ul></div>';

}

?>