<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rubén Díaz <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

define('TITLE', __('Frequently Asked Questions (FAQ)'));

echo '<div class="header_title">'.__('Frequently Asked Questions (FAQ)').'</div>';

echo '<div class="faq">';
echo str_replace('%name', NAME, __('<h2>What is %name?</h2><br />'));

echo str_replace('%url', BASE, str_replace('%name', NAME, __('<p><a href="%url">%name</a> is based on <a href="http://www.jisko.org">Jisko</a>, which is an open-source microblogging application. It\'s source code can be obtained <a href="http://jisko.org">here</a>. You can report bugs or submit patches at their <a href="http://launchpad.net/jisko">Launchpad</a> page.</p><br />')));

echo str_replace('%name', NAME, __('<h2>Using %name</h2><br />'));

echo str_replace('%name', NAME, str_replace('%url', BASE, str_replace('%m_url', BASE.'mobile', __('<p>You can update your %name status from a few places: <ul><li>First, you can simply go to <a href="%url">%url</a>, log in using your username and password, and then you can write your note.</li><br><li>If the admin has enabled it, you can also update from your Jabber account through a Jabber bot.</li><br><li>Or you can also update from your mobile with the <a href="%m_url">mobile adapted site</a>. If you have an iPhone or an iPod touch, you will see a nicer interface adapted to your fingers</li><br /><li>If you have a Wordpress blog, you can use <a href="http://code.google.com/p/wp2jisko/">WP2Jisko</a>, an application that writes a note in %name when a new post is published.</li></ul></p><br />'))));

echo str_replace('%name', NAME, __('<p>To reply one of your buddies\' status, you must first type <strong>@</strong> symbol, then the username of the person who you are going to reply, and then the message. Example: <i>@johndoe hey!</i>.</p><br />'));

echo __('<p>If you prefer to send a private message, you must first type <strong>!</strong> symbol instead of the <strong>@</strong>. It works like replying to a status, but with a different symbol. Example: <i>!johndoe ok, see you there!</i>.</p><br />');

echo str_replace('%name', NAME, __('<h2>%name & Twitter integration</h2><br />'));

echo str_replace('%url', BASE, __('<p>Have you got a Twitter account? Then you can keep informed your followers, at the same time as you read them. Just add your account at the <a href="%url/settings/twitter">Twitter tab</a> and you\'ll be able to do it.</p><br />'));

echo __('<p>You can reply to your Twitter friends\' notes just using the <strong>%</strong> symbol instead of the <strong>@</strong>. It works like replying to a status, but with a different symbol. Example: <i>%Marquitox that sounds good!</i></p><br />');

echo __('<h2>Customize your profile</h2><br />');

echo str_replace('%name', NAME, __('<p>All %name users can customize their profiles. Take a look at the settings page, where you can upload your favorite background image, your avatar or choose a different theme.</p><br />'));

echo __('<h2>Jisko apps</h2>');

echo __('<ul><li><p>If you want, you can send a note every time you update your WordPress blog. <a href="http://code.google.com/p/wp2jisko/">WP2Jisko</a> can do it automagically. All you need to do is installing the plugin, type your username and API Key, and that\'s all. If you want you can customize the message.</p></li><br />');
echo str_replace('%name', NAME, __('<li><p>You can also put your last %name note inside your blog\'s sidebar, using <a href="http://rick.jinlabs.com/code/jisko/">Jisko for WordPress</a>.</p></li></ul><br />'));

if (defined('BLOG') || (defined('WIKI'))) {
	echo __('<h2>That\'s all?</h2><br />');
	
	echo __('If you want to get more information you can go to our ');
	if (defined('BLOG')) {
		echo str_replace('%blog', BLOG, __('<a href="%blog">blog</a>'));
		if (defined('WIKI')) echo str_replace('%wiki', WIKI, __(' and our <a href="%wiki">wiki</a>.'));
		else echo '.';
	}
	else {
		echo str_replace('%wiki', WIKI, __('<a href="%wiki">wiki</a>'));
		if (defined('BLOG')) echo str_replace('%blog', BLOG, __(' and our <a href="%blog">blog</a>.'));
		else echo '.';
	}
}
echo '</div>';

?>