<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rubén Díaz <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

define('NO_GUI', 1);

global $db;
global $_USER;
global $mailing;

if ($_USER['ID']) {
	if (isset($_POST['who'])) {
		$following = (int) $_USER['ID'];
		$who = (int) $_POST['who'];
		
		$follows = (bool) $db->checkFollowing($following, $who);
		if (!$follows) {
			$diff = time() - $_USER['last_follow'];
			if ($diff < WAIT_UNTIL_REFOLLOW) die('ERROR: Cowboy!');
			else {
				$ignored = (bool) in_array($who, $_USER['ignored']);
				if (!$ignored) {
					$userInfo = $db->getUserInfo($who);
					if (!in_array($following, $userInfo['ignored'])) {
						if ($userInfo['notification_level'] == 3 || ($userInfo['notification_level'] == 1)) {
							if ($userInfo['realname']) $content = $userInfo['realname'].' ('.$userInfo['username'].')';
							else $content = $userInfo['username'];
							$mailing->newFollower($_USER['username'], $userInfo['email'], $userInfo['username'], $content, $userInfo['language']);
						}
						$db->dumpRelationship($following, $who);
					}
					else {
						die('ERROR: Ignored user');
					}
					
				}
				else {
					die('ERROR: Ignored user');
				}
			}
		} else {
			$db->removeRelationship($following, $who);
		}
		
		header('Location: '.BASE.'mobile/'.$_POST['username']);
	}
}

?>