<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rub√©n D√≠az <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

global $_USER;
global $db;

$extra = EXTRA;
if (!$extra) {
	if (!$_USER) $extra = 'public';
	else $extra = '';
}
if (strlen($extra) > 0 && ($extra != 'public' && (!$_USER))) die;

if ($extra == 'private' || ($extra == 'private_sent')) {
	echo '<div class="p">';
	echo '<a href="'.MBASE.'notes/private">'.__('Received').'</a> - <a href="'.MBASE.'notes/private_sent">'.__('Sent').'</a>';
	echo '</div>';
}

if (isset($_GET['page'])) $page = $_GET['page']; else $page = 1;
$start = getStart($page);
if($_USER['ignored']) $ignored = $_USER['ignored']; else $ignored = false;

switch ($extra) {
	case 'private':
		$update = $db->updateUnreadPrivates($_USER['username']);
		$name = __('Private notes (Received)');
		$result = $db->getNotes('private', $start, NOTES_PER_PAGE, $_USER['ID'], $_USER['username']);
		$count = $db->countNotes('private', $_USER['username']);
		break;
	case 'private_sent':
		$name = __('Private notes (Sent)');
		$result = $db->getNotes('private_sent', $start, NOTES_PER_PAGE, $_USER['ID'], $_USER['username']);
		$count = $db->countNotes('private', $_USER['username']);
		break;
	case 'replies':
		$name = __('Replies');
		$result = $db->getNotes('replies', $start, NOTES_PER_PAGE, $_USER['ID'], $_USER['username'], $ignored);
		$count = $db->countNotes('reply', $_USER['username'], $ignored);
		break;
	case 'friends':
		$name = __('Friends');
		$result = $db->getNotes('friends', $start, NOTES_PER_PAGE, $_USER['ID'], false, $ignored);
		$count = $db->countNotes('friends', $_USER['ID'], $ignored);
		break;
	case 'twitter':
		$name = __('Twitter');
		$result = $db->getNotes('twitter', $start, NOTES_PER_PAGE, $_USER['ID'], false);
		$count = $db->countNotes('twitter', $_USER['ID']);
		setUpdate();
		break;
	case 'all':
		$name = __('Friends + Twitter');
		$result = $db->getNotes('all', $start, NOTES_PER_PAGE, $_USER['ID'], false, $ignored);
		$count = $db->countNotes('all', $_USER['ID'], $ignored); 
		setUpdate();
		break;
	case 'public':
		$name = __('Public notes');
		$result = $db->getNotes('public', $start, NOTES_PER_PAGE, false, false, $ignored);
		$count = $db->countNotes('public', '', $ignored);
		setUpdate();
		break;
	default:
		if (!empty($_USER['twitter_username'])) {
			if ($_USER['show_twits'] == 0) {
				$name = __('Friends');
				$extra = 'friends';
			}
			else {
				$name = __('Friends + Twitter');
				$extra = 'all';
			}
		}
		else {
			$name = __('Friends');
			$extra = 'friends';
		}
		$result = $db->getNotes($extra, $start, NOTES_PER_PAGE, $_USER['ID'], false, $ignored);
		$count = $db->countNotes($extra, $_USER['ID'], $ignored);
		break;
}
echo '<div class="sn"><strong>'.$name.'</strong></div>';
echo '<table class="n" id="n">';

if (count($result)) {
	foreach ($result as $row) showNoteMobileiPhone($row);
}
else echo '<tr><td style="background:#fff">'.__('No notes were found').'</td></tr>';

echo '</table>';

if ($count > NOTES_PER_PAGE) {
	if ($extra != 'private' && ($extra != 'private_sent' && ($extra != 'replies' && ($extra != 'friends' && ($extra != 'twitter' && ($extra != 'all' && (!empty($extra)))))))) $get = $extra;
	else $get = 'user/'.$extra;
	echo getPaginationStringMobileiPhone($extra);
}

?>