<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rubén Díaz <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

global $_USER;
global $db;

if (isset($_GET['page'])) $page = $_GET['page']; else $page = 1;
$start = getStart($page);
$userInfo = $db->getUserInfo(false, $username);

if(!$userInfo) {
	echo '<strong>';
	echo __('Not found');
	echo '</strong>';
	require 'template/footer.php';
	die;
}

if($_USER && $userInfo['ID'] != $_USER['ID'] && $userInfo['private'] == '1') {
	if($db->checkFollowing($userInfo['ID'], $_USER['ID'])) {
		define('VIEWABLE', 1);
	}
} elseif($userInfo['private'] == '0') {
	define('VIEWABLE', 1);
}

if($_USER && $_USER['username'] == $userInfo['username'] && !is_numeric($other)) {
	header('Location: '.BASE.'mobile/notes/');
	die;
}

if(!defined('VIEWABLE')) {
	echo '<strong>';
	echo __('Not allowed');
	echo '</strong>';
	echo '<br />';
	echo __('You aren\'t allowed to see this user\'s profile.');
	require 'template/footer.php';
	die;
}

if(is_numeric($other)) {
	if($db->checkNote($other, $userInfo['ID'])) {
		echo '<ul class="n">
		<li><strong>'.__('Note').'</strong></li>';
		showNoteMobile(array('id'=>intval($other)));
		echo '</ul>';
	}
} else {
	$result = $db->getNotes('archive', $start, NOTES_PER_PAGE, $userInfo['ID']);
	$count = $db->countNotes('archive', $userInfo['ID']);
	$tmp_string = __('%username\'s profile');
	$string = str_replace('%username', $userInfo['username'], $tmp_string);
	echo '<ul class="n">
	<li><strong>'.$string.'</strong></li></ul><form method="post" action="'.BASE.'mobile/follow">';
	if (!$db->checkFollowing($_USER['ID'],$userInfo['ID'])) $string = __('Follow');
	else $string = __('Unfollow');
	
	echo '<input type="hidden" name="who" value="'.$userInfo['ID'].'"><input type="hidden" name="username" value="'.$userInfo['username'].'">
	<input type="submit" value="'.$string.'" class="b"></form><ul class="n">';
	if(count($result)) {
		foreach ($result as $row) showNoteMobile($row);
	} else {
		echo '<li>' . __('No notes were found') . '</li>';
	}
	echo '</ul>';
}

?>