<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rubn Daz <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

global $db;
global $_USER;

if (!$PARAMS) {
	define('TITLE', __('Tags statistics'));
	
	echo '<div class="header_title">'.__('Tags statistics').'</div><br><br>';
	
	echo '<div style="width:260px;float:right;"><div class="header_title">'.__('Most used tags - last week').'</div>';
	
	$query = $db->send("SELECT `tag`, COUNT(`id`) FROM tags_n WHERE (UNIX_TIMESTAMP() - `timestamp`) < 604800 GROUP BY `tag` ORDER BY COUNT(`id`) DESC LIMIT 5");
	
	echo '<table style="width:250px"><thead><tr style="font-size:13px;font-family:Arial;font-weight:600;color: rgb(74, 101, 107)"><td>'.__('Name').'</td><td style="text-align:center;width:60px">'.__('Number of posts').'</td></tr></thead>';
	while ($row = mysql_fetch_row($query)) {
		echo '<tr><td><a href="'.BASE.'tag/'.$row[0].'">#'.$row[0].'</a></td><td style="text-align:center">'.$row[1].'</td></tr>';
	}
	echo '</table></div>';
	
	echo '<div style="width:250px;"><div class="header_title">'.__('Most used tags - today').'</div>';
	
	$query = $db->send("SELECT `tag`, COUNT(`id`) FROM tags_n WHERE (UNIX_TIMESTAMP() - `timestamp`) < 86400 GROUP BY `tag` ORDER BY COUNT(`id`) DESC LIMIT 5");
	
	echo '<table style="width:250px"><thead><tr style="font-size:13px;font-family:Arial;font-weight:600;color: rgb(74, 101, 107)"><td>'.__('Name').'</td><td style="text-align:center;width:60px">'.__('Number of posts').'</td></tr></thead>';
	while ($row = mysql_fetch_row($query)) {
		echo '<tr><td><a href="'.BASE.'tag/'.$row[0].'">#'.$row[0].'</a></td><td style="text-align:center">'.$row[1].'</td></tr>';
	}
	echo '</table></div><br><br>';
	
	echo '<div style="width:260px;float:right;"><div class="header_title">'.__('Most used tags - everytime').'</div>';
	
	$query = $db->send("SELECT `tag`, COUNT(`id`) FROM tags_n GROUP BY `tag` ORDER BY COUNT(`id`) DESC LIMIT 5");
	
	echo '<table style="width:250px"><thead><tr style="font-size:13px;font-family:Arial;font-weight:600;color: rgb(74, 101, 107)"><td>'.__('Name').'</td><td style="text-align:center;width:60px">'.__('Number of posts').'</td></tr></thead>';
	while ($row = mysql_fetch_row($query)) {
		echo '<tr><td><a href="'.BASE.'tag/'.$row[0].'">#'.$row[0].'</a></td><td style="text-align:center">'.$row[1].'</td></tr>';
	}
	echo '</table></div>';
	
	echo '<div style="width:250px;"><div class="header_title">'.__('Most used tags - last month').'</div>';
	
	$query = $db->send("SELECT `tag`, COUNT(`id`) FROM tags_n WHERE (UNIX_TIMESTAMP() - `timestamp`) < 18144000 GROUP BY `tag` ORDER BY COUNT(`id`) DESC LIMIT 5");
	
	echo '<table style="width:250px"><thead><tr style="font-size:13px;font-family:Arial;font-weight:600;color: rgb(74, 101, 107)"><td>'.__('Name').'</td><td style="text-align:center;width:60px">'.__('Number of posts').'</td></tr></thead>';
	while ($row = mysql_fetch_row($query)) {
		echo '<tr><td><a href="'.BASE.'tag/'.$row[0].'">#'.$row[0].'</a></td><td style="text-align:center">'.$row[1].'</td></tr>';
	}
	echo '</table></div><br><br>';
	
	echo '<div style="width:260px;float:right"><div class="header_title">'.__('Tags with better writing rate').'</div>';
	
	$query = $db->send("SELECT t2.tag, t1.name, (UNIX_TIMESTAMP() - t1.timestamp) as `timestamp`, COUNT(t2.id) as `count`, ROUND((COUNT(t2.id)/(UNIX_TIMESTAMP() - t1.timestamp))*60, 2) as `calc` FROM `tags_c` AS t1, `tags_n` AS t2 WHERE t1.name = t2.tag GROUP BY t2.tag ORDER BY `calc` DESC LIMIT 5");
	
	echo '<table style="width:260px"><thead><tr style="font-size:13px;font-family:Arial;font-weight:600;color: rgb(74, 101, 107)"><td>'.__('Name').'</td><td style="text-align:center">'.__('Writing rate').'</td><td style="text-align:center;width:60px">'.__('Number of posts').'</tr></thead>';
	while ($row = mysql_fetch_row($query)) {
		echo '<tr><td><a href="'.BASE.'tag/'.$row[0].'">#'.$row[0].'</a></td><td style="text-align:center">'.$row[4].'</td><td style="text-align:center">'.$row[3].'</tr>';
	}
	echo '</table></div>';

	
	echo '<div style="width:250px"><div class="header_title">'.__('Users that created most tags').'</div>';
	
	$query = $db->send("SELECT founder, name, COUNT(name) FROM tags_c GROUP BY founder DESC LIMIT 5");
	
	echo '<table style="width:250px"><thead><tr style="font-size:13px;font-family:Arial;font-weight:600;color: rgb(74, 101, 107)"><td>'.__('Nickname').'</td><td style="text-align:center;width:60px">'.__('Created tags').'</td></tr></thead>';
	while ($row = mysql_fetch_row($query)) {
		$nickname = $db->getUserInfo($row[0]);
		echo '<tr><td><a href="'.BASE.$nickname['username'].'">@'.$nickname['username'].'</a></td><td style="text-align:center">'.$row[2].'</td></tr>';
	}
	echo '</table>';
	
	echo '</div><br><br>';
}
else {
	if (strlen($PARAMS) > 20) header('Location: '.BASE.'home');
	else {
		$PARAMS = utf8_htmlentities(mysql_escape_string($PARAMS));
		define('TITLE', __('Tag').' #'.$PARAMS);
		
		echo '<div class="header_title">'.__('Notes with the tag').' #'.$PARAMS.'</div>';
		echo '<div id="note_list">';
		
		if (!$db->checkTag($PARAMS)) echo showStatus(__("There are no notes with this tag."), 'warning');
		else {
			if (isset($_GET['p'])) $start = getStart($_GET['p']); else $start = getStart(1);
	
			$result = $db->getNotes('tag', $start, NOTES_PER_PAGE, $PARAMS);
			
			$count = $db->countNotes('tag', $PARAMS);
			
			foreach ($result as $note) showNote($note, false, false, true);
			echo getPaginationString($PARAMS, $count, $_GET['p'], NOTES_PER_PAGE, 1, '?p=');
			
		}
		
		echo '</div>';
	}
}

?>