<?php
# Jisko: An open-source microblogging application
# Copyright (C) 2010 Rub√©n D√≠¬≠az <outime@gmail.com>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

define('PATH', dirname(__FILE__) . '/../../');

require(PATH.'config.php');
require(PATH.'includes/functions.php');
require(PATH.'includes/db.php');
require(PATH.'includes/gettext.php');
require(PATH.'includes/streams.php');

$db = new DB(DB_HOST, DB_PORT, DB_USER, DB_PASSWORD);
if (!$db) die('MySQL error! Check your config.php');
$db->select(DB_NAME);

checkUser();

global $_USER;

header('content-type: text/javascript');
ob_start('ob_gzhandler');

$section = trim(strtolower($_GET['section']));
$page = intval($_GET['page']);

if(!($page > 1))
	$page = 1;
?>

function count(input, inputcount, limit) {
	if (input.value.length > limit) {
		input.value = input.value.substring(0, limit);
	} else {
		inputcount.value = limit - input.value.length;
	}
}

function showUpload() {
	$("#thenoteform").css("display","none");
	$("#upload_send").html("<input type=\"file\" class=\"green_input\" name=\"attach\">");
	$("div:hidden:first").fadeIn("slow");
}

function follow(who, button) {
	layer = "#" + button;
	$(layer).attr("disabled",true);
	$("#loading").html("<?php echo __('Working...'); ?>");
	$('#loading').fadeIn('fast');
	$.post("<?php echo BASE ?>ajax/follow",{who:who},function(data) {
		if (/^ERROR:/.test(data)) {
			$("#loading").html('<img src="<?php echo BASE; ?>static/img/smileys/cry.png">');
			data = data.replace('ERROR: ', '');
			alert(data);
			$("#loading").fadeOut("fast");
		} else {
			value = $(layer).attr('value');
			var allFollowers = $("#sfollowers").html();
			if (value == "<?php echo __('Follow') ?>") {
				$(layer).attr('value',"<?php echo __('Unfollow') ?>");
				$("#sfollowers").html(++allFollowers);
			} else {
				$(layer).attr('value',"<?php echo __('Follow') ?>");
				if (allFollowers == 1) { var modify = 0; }
				else { var modify = --allFollowers; }
				$("#sfollowers").html(""+modify+"");	
			}
			$("#loading").fadeOut("fast");
		}
	});
	$(layer).attr("disabled",false);
}

function ignore(who, button) {
	layer = "#" + button;
	$(layer).attr("disabled",true);
	$("#loading").html("<?php echo __('Working...'); ?>");
	$('#loading').fadeIn('fast');
			$.post("<?php echo BASE ?>ajax/ignore",{who:who},function() {
				value = $(layer).attr('value');
					if (value == "<?php echo __('Ignore') ?>") {
						if(typeof followbtn !== undefined) {
							followlayer = "#" + followbtn;
							$(followlayer).attr('value', "<?php echo __('Follow') ?>");
							$(followlayer).attr('disabled', true);
						}
						$(layer).attr('value',"<?php echo __('Unignore') ?>");
					} else {
						if(typeof followbtn !== undefined) {
							followlayer = "#" + followbtn;
							$(followlayer).attr('value', "<?php echo __('Follow') ?>");
							$(followlayer).attr('disabled', false);
						}
						$(layer).attr('value',"<?php echo __('Ignore') ?>");
					}
					$("#loading").fadeOut("fast");
				}
			);
	$(layer).attr("disabled",false);
}

function favorite(note) {
	var icons = new Array(2);
	icons[0] = '<?php echo BASE ?>static/img/icons/fav_add.png';
	icons[1] = '<?php echo BASE ?>static/img/icons/fav_del.png';
	var layer = "fav"+note;
	var src = document.getElementById(layer).src;
	$("#loading").html("<?php echo __('Working...'); ?>");
	$('#loading').fadeIn('fast');
	if (src == icons[0]) {
		$.get("<?php echo BASE ?>ajax/favorite?rand=" + Math.random(),{id:note},function(data) {
			document.getElementById(layer).src = icons[1];
			var allFavorites = $("#sfavorites").html();
			$("#sfavorites").html(++allFavorites);
			$("#loading").fadeOut("fast");
		});
	}
	else {
		$.get("<?php echo BASE ?>ajax/favorite?rand=" + Math.random(),{id:note},function(data) {
			document.getElementById(layer).src = icons[0];
			var allFavorites = $("#sfavorites").html();
			$("#sfavorites").html(""+--allFavorites+"");
			$("#loading").fadeOut("fast");
		});
	}
}

function reloadNotes() {
	<?php if ($section) { ?>
	$("#loading").html("<?php echo __('Fetching notes...'); ?>");
	$('#loading').fadeIn('fast');
	<?php 
		if ($_USER) echo "var islogged = true;\n";
		else echo "var islogged = false;\n"; ?>
	$.getJSON('<?php echo BASE ?>ajax/<?php echo $section ?>',{page:"<?php echo $page ?>", rand: Math.random()},function(json) {
		$("#note_list").css("display","none");
		$("#note_list").html('');
		
		for(i=0; i < json.length; i++) {
			var divNote = document.createElement('div');
			if (json[i].replying === true) { divNote.className = 'note unread'; }
			else if (json[i].type == 'twitter') { divNote.className = 'note_t'; }
			else divNote.className = 'note';
			divNote.id = 'status_' + json[i].id;
			divAvatarNote = document.createElement('div');
			divAvatarNote.className = 'avatar_note';
			var inner = '<img src="' + json[i].avatar + '" alt="avatar"';
			if (json[i].type != 'twitter' && (json[i].type != 'twitter_reply')) { inner += ' onmouseover="tooltip.ajax_delayed(event, \'profile\', \'' + json[i].user_id + '\');" onmouseout="tooltip.hide(event);"'; }
			divAvatarNote.innerHTML = inner + ' width="48" height="48"/>';
			divNote.appendChild(divAvatarNote);
			divInfoNote = document.createElement('div');
			divInfoNote.className = 'info_note';
			divUserNote = document.createElement('div');
			divUserNote.className = 'user_note';
			var inner = '<a href="<?php echo BASE; ?>' + json[i].username + '"';
			if (json[i].type != 'twitter'  && (json[i].type != 'twitter_reply')) { inner += ' onmouseover="return tooltip.ajax_delayed(event, \'profile\', \'' + json[i].user_id + '\');" onmouseout="tooltip.hide(event);"'; }
			divUserNote.innerHTML = inner + '>' + json[i].username + '</a>';
			divInfoNote.appendChild(divUserNote);
			divActionsNote = document.createElement('div');
			divActionsNote.className = 'actions_note';
			divActionsNote.id = 'actions_' + json[i].id;
			var actions = '';
			<?php if ($_USER) { ?>
			if (json[i].user_id == <?php echo $_USER['ID']; ?>) { actions = '&nbsp;<a href="<?php echo BASE; ?>notes/delete?id=' + json[i].id + '" onclick="return confirm(\"<?php echo __('Are you sure? There is NO UNDO!'); ?>\");"><img src="<?php echo BASE; ?>static/img/icons/delete.png" alt="<?php echo __('Delete note'); ?>" title="<?php echo __('Delete note'); ?>" /></a>'; }
			<?php } ?>
			if (json[i].attached_file) {
				actions += '&nbsp;<a href="<?php echo BASE; ?>download/' + json[i].id + '/' + json[i].attached_file + '" rel="nofollow">';
				actions += '<img src="<?php echo BASE; ?>static/img/icons/download.png" alt="<?php echo __('Download file'); ?>" title="<?php echo __('Download file'); ?>" /></a>';
			}
			if (islogged === true && (json[i].type == 'public' && (json[i].type != 'twitter' && (json[i].type != 'twitter_reply')))) {
				if (json[i].favorite) { actions += '&nbsp;<img src="<?php echo BASE; ?>static/img/icons/fav_del.png" id="fav' + json[i].id + '" alt="<?php echo __('Delete favorite'); ?>" title="<?php echo __('Delete favorite'); ?>" onclick="favorite(' + json[i].id + ');" style="cursor: pointer;" />'; }
				else { actions += '&nbsp;<img src="<?php echo BASE; ?>static/img/icons/fav_add.png" id="fav' + json[i].id + '" alt="<?php echo __('Add to favorites'); ?>" title="<?php echo __('Add to favorites'); ?>" onclick="favorite(' + json[i].id + ');" style="cursor: pointer;" />'; }
			}
			if (json[i].type != 'private') {
				if (json[i].type != 'twitter' && (json[i].type != 'twitter_reply')) { actions += '&nbsp;<a href="<?php echo BASE; ?>' + json[i].username + '/' + json[i].id + '" title="Permalink"><img src="<?php echo BASE; ?>static/img/icons/plink.png" alt="Permalink" /></a>'; }
				else { actions += '&nbsp;<a href="http://twitter.com/' + json[i].username + '/statuses/' + json[i].id + '" title="Permalink"><img src="<?php echo BASE; ?>static/img/icons/plink.png" alt="Permalink" /></a>'; }
			}
			if (islogged === true && ('<?php echo $_USER['username']; ?>' != json[i].username)) {
				actions += '&nbsp;<a onclick="document.note_form.note.value';
				if (json[i].type == 'twitter') { var network = '%'; }
				else if (json[i].type == 'private') { var network = '!'; }
				else { var network = '@'; }
				actions += ' += \'' + network + json[i].username + ' \';';
				actions += 'document.note_form.note.focus(); return false;" href="" title="Reply"><img src="<?php echo BASE; ?>static/img/icons/reply.png" alt="<?php echo __('Reply'); ?>" /></a>';
			}
			divActionsNote.innerHTML = actions;
			divInfoNote.appendChild(divActionsNote);
			divDateNote = document.createElement('div');
			divDateNote.className = 'date_note';
			datenote = json[i].time_ago + ' (<span class="from">';
			if (json[i].from == 'mobile') { datenote = datenote + '<img src="<?php echo BASE; ?>static/img/icons/phone.png" title="<?php echo __('mobile'); ?>">)</span>'; }
			else if (json[i].type == 'twitter') { datenote = datenote + 'twitter)</span>'; }
			else { datenote = datenote + json[i].from + ')</span>'; }
			divDateNote.innerHTML = datenote;
			divInfoNote.appendChild(divDateNote);
			divNote.appendChild(divInfoNote);
			divTextNote = document.createElement('div');
			divTextNote.className = 'text_note';
			divTextNote2 = document.createElement('div');
			divTextNote2.id = 'text_note_' + json[i].id;
			divTextNote2.innerHTML = json[i].text;
			divTextNote.appendChild(divTextNote2);
			divNote.appendChild(divTextNote);
			divSeparator = document.createElement('div');
			divSeparator.className = 'separator';
			divNote.appendChild(divSeparator);
			document.getElementById('note_list').appendChild(divNote);
		}
		$("#loading").fadeOut("fast");
		$("#note_list").fadeIn("slow");
		$("#ttnote,#btsend").attr("disabled",false);
	});
	<?php } ?>
	
	var notes = $("#ajax_notes").html();
	var privates = $("#ajax_privates").html();
	
	$.getJSON("<?php echo BASE; ?>ajax/mainpage", { notes: notes, privates: privates}, function(json) {
		if (json.notes) { $("#ajax_notes").html(json.notes); }
		if (json.privates) {
			$("#ajax_privates").html(json.privates);
			content = $("#private_tab").attr('class');
			$("#private_tab").attr('class', content+' unread');
		}
	});
}

function doSimpleNoteForm() {
	var note = $("#ttnote").attr("value");
	var layer = $("#thenoteform").html();
	$.post("<?php echo BASE ?>ajax/normalform/",{note:note},function(data) {
    	$("#thenoteform").css("display","none");
        $("#thenoteform").html(data);
	$("#thenoteform").fadeIn("slow");
        $("#upload_send").html("<input type=\"file\" class=\"green_input\" name=\"attach\">");
        $("#simplepost").keypress(function (e) {
		if (e.which == 13) {
			document.getElementById("sendbutton").click();
			return false;
		} /*e.which*/
	} /* function keypress ON*/
); /* simplepost ready */
});
    
}

function showLoading() {
	$("#loading").html("<?php echo __('Loading...'); ?>");
	$('#loading').fadeIn('fast');
}

function startLogin() {
	$("#loading").html("<?php echo __('Logging In...'); ?>");
	$('#loading').fadeIn('fast');
}

$(document).ready(
	function(){
		$("#ttnote").focus();
		$("#ttnote").keypress(function (e) {
			if (e.which == 13) {
				if($(this).attr("value") == '') { return false; }
				$("#ttnote").attr('disabled', 'disabled');
				$("#btsend").attr('disabled', 'disabled');
				$("#loading").html("<?php echo __('Publishing...'); ?>");
				$('#loading').fadeIn('fast');
				var note = $(this).attr("value");
				var auth = $("#hiddenkey", document.body).attr("value");
				clearInterval(timerID);
				$.post("<?php echo BASE ?>ajax/post",{auth:auth,note:note},function(data) {
					if (/^ERROR:/.test(data)) {
						$("#loading").html('<img src="<?php echo BASE; ?>static/img/smileys/cry.png">');
						data = data.replace('ERROR: ', '');
						alert(data);
						$("#ttnote").attr("disabled", false);
						$("#btsend").attr("disabled", false);
						$("#loading").fadeOut("fast");
					} else {
						$("#ttnote").attr("value", '');
						$("#ajax_notes").html(($("#ajax_notes").html() / 1)+1);
						reloadNotes();
						$("#loading").fadeOut("fast");
						timerID = setInterval("reloadNotes()",25000);
						$("#ttnote,#btsend").attr("disabled",false);
						$("#latest_note").html(note);
						$(".counter_send .counter").attr('value',140);
					}
				}); /*endpost*/
			} /*e.which*/
	}); 
	
	$("#simplepost").keypress(function (e) {
		if (e.which == 13) {
			document.getElementById("sendbutton").click();
			return false;
		} /*e.which*/
	}); 
	
	/*$("#status_x").mouseover(function(){
		$("#actions_x").fadeIn("fast");
	}).mouseout(function(){
		$("#actions_x").fadeOut("fast");
	});*/
	
	$("a[class^='external']").attr('target','_blank');
 
	$("#btsend").click(function() {
		$("#ttnote,#btsend").attr("disabled",true);
		var note = $("#ttnote").attr("value");
		var auth = $("#hiddenkey", document.body).attr("value");
		$("#loading").html("<?php echo __('Publishing...'); ?>");
		$('#loading').fadeIn('fast');
		clearInterval(timerID);
			$.post("<?php echo BASE ?>ajax/post",{auth:auth,note:note},function(data) {
				if (/^ERROR:/.test(data)) {
					$("#loading").html('<img src="<?php echo BASE; ?>static/img/smileys/cry.png">');
					data = data.replace('ERROR: ', ''); /*error*/
					alert(data);
					$("#ttnote,#btsend").attr("disabled",false);
					$("#loading").fadeOut("fast");
				} else {
					$("#ttnote").attr("value", '');
					reloadNotes();
					timerID = setInterval("reloadNotes()",25000);
					$("#ttnote,#btsend").attr("disabled",false);
					$("#latest_note").html(note);
					$(".counter_send .counter").attr('value',140);
				}
			}); /* post */
	}); /* end btsend click */
}); /* document ready*/